#include <stdio.h>
#include <string.h>

typedef unsigned char UCHAR;
typedef unsigned int UINT32;

#define VERSIONDATA_TAG	"NegitoroOS [Version 0.0.0.1]\n\
Copyright (c) 2009 Negitoro OS Project.\n"

/* asmhead.nas */
struct BOOTINFO { /* 0x0ff0-0x0fff */
	char cyls; /* u[gZN^͂ǂ܂ŃfBXNǂ񂾂̂ */
	char leds; /* u[g̃L[{[hLED̏ */
	char vmode; /* rfI[h  rbgJ[ */
	char reserve;
	short scrnx, scrny; /* ʉ𑜓x */
	char *vram;
};
#define ADR_BOOTINFO	0x00000ff0
#define ADR_DISKIMG		0x00100000
#define APM_VERSION		0x1ff0
#define VBE_VERSION		0x1ff3

/* stdlib.h */
int rand(void);			/* 0`32797 */
int atoi(const char *s);

/* naskfunc.nas */
void io_hlt(void);
void io_cli(void);
void io_sti(void);
void io_stihlt(void);
int io_in8(int port);
void io_out8(int port, int data);
int io_load_eflags(void);
void io_store_eflags(int eflags);
void load_gdtr(int limit, int addr);
void load_idtr(int limit, int addr);
int load_cr0(void);
void store_cr0(int cr0);
void load_tr(int tr);
void asm_inthandler0c(void);
void asm_inthandler0d(void);
void asm_inthandler20(void);
void asm_inthandler21(void);
void asm_inthandler2c(void);
void asm_inthandler23(void);
void asm_inthandler24(void);
void asm_inthandler26(void);
unsigned int memtest_sub(UINT32 start, UINT32 end);
void farjmp(int eip, int cs);
void farcall(int eip, int cs);
void asm_hrb_api(void);
void start_app(int eip, int cs, int esp, int ds, int *tss_esp0);
void asm_end_app(void);
void clts(void);
void fnsave(int *addr);
void frstor(int *addr);
void asm_inthandler07(void);

/* fifo.c */
struct FIFO32 {
	int *buf;
	int p, q, size, free, flags;
	struct TASK *task;
};
void fifo32_init(struct FIFO32 *fifo, int size, int *buf, struct TASK *task);
int fifo32_put(struct FIFO32 *fifo, int data);
int fifo32_get(struct FIFO32 *fifo);
int fifo32_status(struct FIFO32 *fifo);

/* memory.c */
#define MEMMAN_FREES		4090	/* Ŗ32KB */
#define MEMMAN_ADDR			0x003c0000
struct FREEINFO {	/*  */
	unsigned int addr, size;
};
struct MEMMAN {		/* Ǘ */
	int frees, maxfrees, lostsize, losts;
	struct FREEINFO free[MEMMAN_FREES];
	int disp;
};
unsigned int memtest(unsigned int start, unsigned int end);
void memman_init(struct MEMMAN *man);
unsigned int memman_total(struct MEMMAN *man);
unsigned int memman_alloc(struct MEMMAN *man, unsigned int size);
int memman_free(struct MEMMAN *man, unsigned int addr, unsigned int size);
unsigned int memman_alloc_4k(unsigned int size);
int memman_free_4k(unsigned int addr, unsigned int size);
unsigned int init_memory(void);

/* sheet.c */
#define MAX_SHEETS		256
#define SHEET_USE		1
struct SHEET {
	unsigned char *buf;
	int bxsize, bysize, vx0, vy0, col_inv, height, flags;
	struct SHTCTL *ctl;
	struct TASK *task;
	int id;
};
struct SHTCTL {
	unsigned char *vram, *map;
	int xsize, ysize, top;
	struct SHEET *sheets[MAX_SHEETS];
	struct SHEET sheets0[MAX_SHEETS];
	struct SHEET *active;	/* ANeBuȃEBhE */
};
struct SHTCTL *shtctl_init(unsigned char *vram);
struct SHEET *sheet_alloc(void);
void sheet_setbuf(struct SHEET *sht, unsigned char *buf, int xsize, int ysize, int col_inv);
void sheet_updown(struct SHEET *sht, int height);
void sheet_refresh(struct SHEET *sht, int bx0, int by0, int bx1, int by1);
void sheet_slide(struct SHEET *sht, int vx0, int vy0);
void sheet_free(struct SHEET *sht);

/* graphic.c */
void init_screen8(char *vram);
void effect_screen(int id, int act);
void boxfill8(unsigned char *vram, int xsize, unsigned char c, int x0, int y0, int x1, int y1);
void putfont8(char *vram, int xsize, int x, int y, char c, char *font);
void putfonts8_asc(char *vram, int xsize, int x, int y, char c, unsigned char *s);
void init_mouse_cursor8(char *mouse, char bc);
void putblock8_8(char *vram, int vxsize, int pxsize,
	int pysize, int px0, int py0, char *buf, int bxsize);
#define COL8_000000		0
#define COL8_FF0000		1
#define COL8_00FF00		2
#define COL8_FFFF00		3
#define COL8_0000FF		4
#define COL8_FF00FF		5
#define COL8_00FFFF		6
#define COL8_FFFFFF		7
#define COL8_C6C6C6		8
#define COL8_840000		9
#define COL8_008400		10
#define COL8_848400		11
#define COL8_000084		12
#define COL8_840084		13
#define COL8_008484		14
#define COL8_848484		15
void set_backscreen(struct SHEET *sht, char *wallname);
void loading_screen(struct SHEET *sht);
void hrb_api_linewin(struct SHEET *sht, int x0, int y0, int x1, int y1, int col);
void showmemory_screen(void);
int draw_picture(struct SHEET *sht, char *fname, int posx, int posy);

/* color.c */
struct RGB {
	unsigned char b, g, r, t;
};
struct DLL_STRPICENV {	/* 64KB */
	int work[64 * 1024 / 4];
};
unsigned char rgb2pal(int r, int g, int b, int x, int y);
void init_palette(void);
void set_palette(int start, int end, unsigned char *rgb);

/* dsctbl.c */
struct SEGMENT_DESCRIPTOR {
	short limit_low, base_low;
	char base_mid, access_right;
	char limit_high, base_high;
};
struct GATE_DESCRIPTOR {
	short offset_low, selector;
	char dw_count, access_right;
	short offset_high;
};
void init_gdtidt(void);
void set_segmdesc(struct SEGMENT_DESCRIPTOR *sd, unsigned int limit, int base, int ar);
void set_gatedesc(struct GATE_DESCRIPTOR *gd, int offset, int selector, int ar);
#define ADR_IDT			0x0026f800
#define LIMIT_IDT		0x000007ff
#define ADR_GDT			0x00270000
#define LIMIT_GDT		0x0000ffff
#define ADR_BOTPAK		0x00280000
#define LIMIT_BOTPAK	0x0007ffff
#define AR_DATA32_RW	0x4092
#define AR_CODE32_ER	0x409a
#define AR_LDT			0x0082
#define AR_TSS32		0x0089
#define AR_INTGATE32	0x008e

/* int.c */
void init_pic(void);
#define PIC0_ICW1		0x0020
#define PIC0_OCW2		0x0020
#define PIC0_IMR		0x0021
#define PIC0_ICW2		0x0021
#define PIC0_ICW3		0x0021
#define PIC0_ICW4		0x0021
#define PIC1_ICW1		0x00a0
#define PIC1_OCW2		0x00a0
#define PIC1_IMR		0x00a1
#define PIC1_ICW2		0x00a1
#define PIC1_ICW3		0x00a1
#define PIC1_ICW4		0x00a1

/* keyboard.c */
void inthandler21(int *esp);
void wait_KBC_sendready(void);
void init_keyboard(struct FIFO32 *fifo, int data0);
#define PORT_KEYDAT	0x0060
#define PORT_KEYCMD	0x0064

/* mouse.c */
struct MOUSE_DEC {
	unsigned char buf[3], phase;
	int x, y, btn;
};
struct MINFO {
	int x, y, button, state;
};
void inthandler2c(int *esp);
void enable_mouse(struct FIFO32 *fifo, int data0, struct MOUSE_DEC *mdec);
int mouse_decode(struct MOUSE_DEC *mdec, unsigned char dat);
extern struct MINFO mf;

/* timer.c */
#define MAX_TIMER 500
struct TIMER {
	struct TIMER *next;
	unsigned int timeout;
	char flags, flags2;
	struct FIFO32 *fifo;
	int data;
};
struct TIMERCTL {
	unsigned int count, next;
	struct TIMER *t0;
	struct TIMER timers0[MAX_TIMER];
};
extern struct TIMERCTL timerctl;
void init_pit(void);
struct TIMER *timer_alloc(void);
void timer_free(struct TIMER *timer);
void timer_init(struct TIMER *timer, struct FIFO32 *fifo, int data);
void timer_settime(struct TIMER *timer, unsigned int timeout);
void inthandler20(int *esp);
int timer_cancel(struct TIMER *timer);
void timer_cancelall(struct FIFO32 *fifo);
void kernel_sleep(unsigned int time);

/* mtask.c */
#define MAX_TASKS		1000	/* ő^XN */
#define TASK_GDT0		3		/* TSSGDT̉Ԃ犄蓖Ă̂ */
#define MAX_TASKS_LV	100
#define MAX_TASKLEVELS	10
struct TSS32 {
	int backlink, esp0, ss0, esp1, ss1, esp2, ss2, cr3;
	int eip, eflags, eax, ecx, edx, ebx, esp, ebp, esi, edi;
	int es, cs, ss, ds, fs, gs;
	int ldtr, iomap;
};
struct TASK {
	int sel, flags; /* selGDT̔ԍ̂ */
	int level, priority;
	struct FIFO32 fifo;
	struct TSS32 tss;
	int fpu[108 / 4];
	struct SEGMENT_DESCRIPTOR ldt[2];
	struct CONSOLE *cons;
	int ds_base, cons_stack;
	struct FILEHANDLE *fhandle;
	int *fat;
	char *cmdline;
	unsigned char langmode, langbyte1;
	char taskname[64];
	int id;
};
struct TASKLEVEL {
	int running; /* 삵Ă^XN̐ */
	int now; /* ݓ삵Ă^XNǂꂾ悤ɂ邽߂̕ϐ */
	struct TASK *tasks[MAX_TASKS_LV];
};
struct TASKCTL {
	int now_lv; /* ݓ쒆̃x */
	struct TASK *task_fpu; /* FPU */
	char lv_change; /* ^XNXCb`̂ƂɁAxςقǂ */
	struct TASKLEVEL level[MAX_TASKLEVELS];
	struct TASK tasks0[MAX_TASKS];
};
extern struct TASKCTL *taskctl;
extern struct TIMER *task_timer;
struct TASK *task_now(void);
struct TASK *task_init(void);
struct TASK *task_alloc(void);
void task_run(struct TASK *task, int level, int priority, char *taskname);
void task_switch(void);
void task_sleep(struct TASK *task);
int *inthandler07(int *esp);

/* window.c */
void draw_window8(unsigned char *buf, int xsize, int ysize, char *title, char act);
void putfonts8_asc_sht(struct SHEET *sht, int x, int y, int c, int b, char *s, int l);
void draw_textbox8(struct SHEET *sht, int x0, int y0, int sx, int sy, int c);
void draw_wtitle8(unsigned char *buf, int xsize, char *title, char act);
void change_wtitle8(struct SHEET *sht, char act);
void init_taskbar(void);
void set_taskbar(int id, char *name);
void delete_taskbar(char *name);
struct SHEET *make_window(char *wname, int ww, int wh, int act, int col_inv);
void break_window(struct SHEET *sht);


/* console.c */
struct CONSOLE {
	struct SHEET *sht;
	int cur_x, cur_y, cur_c;
	struct TIMER *timer;
	int ch;
};
struct FILEHANDLE {
	char *buf;
	int size;
	int pos;
};
void close_console(struct SHEET *sht);
void close_constask(struct TASK *task);
void console_task(struct SHEET *sheet, int memtotal);
struct TASK *open_constask(struct SHEET *sht);
struct SHEET *open_console(void);
void cons_putchar(struct CONSOLE *cons, int chr, char move);
void cons_newline(struct CONSOLE *cons);
void cons_putstr0(struct CONSOLE *cons, char *s);
void cons_putstr1(struct CONSOLE *cons, char *s, int l);
int *inthandler0d(int *esp);
int *inthandler0c(int *esp);
void cons_runcmd(char *cmdline, struct CONSOLE *cons, int *fat, int memtotal);

/* api.c */
struct DATE {
	int year, month, day, hour, minutes, second;
};
int *hrb_api(int edi, int esi, int ebp, int esp, int ebx, int edx, int ecx, int eax);

/* command.c */
void cmd_mem(struct CONSOLE *cons, int memtotal);
void cmd_cls(struct CONSOLE *cons);
void cmd_dir(struct CONSOLE *cons, char *cmdline);
void cmd_exit(struct CONSOLE *cons, int *fat);
void cmd_start(struct CONSOLE *cons, char *cmdline);
void cmd_ncst(struct CONSOLE *cons, char *cmdline);
void cmd_lmod(struct CONSOLE *cons, char *cmdline);
void cmd_reset(struct CONSOLE *cons);
int cmd_app(struct CONSOLE *cons, int *fat, char *cmdline);
void cmd_tdev(struct CONSOLE *cons);
void cmd_ps(struct CONSOLE *cons);
void cmd_klog(struct CONSOLE *cons);
void cmd_dlog(struct CONSOLE *cons);
void cmd_kill(struct CONSOLE *cons, char *cmdline);
void cmd_date(struct CONSOLE *cons);
void cmd_help(struct CONSOLE *cons);
void cmd_crfile(struct CONSOLE *cons, int *fat, char *cmdline);
void cmd_rmfile(struct CONSOLE *cons, int *fat, char *cmdline);
void cmd_rnfile(struct CONSOLE *cons, int *fat, char *cmdline);
void cmd_test(struct CONSOLE *cons, int *fat);
void cmd_tser(struct CONSOLE *cons, char *cmdline);
void cmd_ver(struct CONSOLE *cons);
void cmd_bootd(struct CONSOLE *cons);
void cmd_wallp(struct CONSOLE *cons, char *cmdline);

/* file.c */
struct FILEINFO {
	unsigned char name[8], ext[3], type;
	char reserve[10];
	unsigned short time, date, clustno;
	unsigned int size;
};
void file_readfat(int *fat, unsigned char *img);
void file_loadfile(int clustno, int size, char *buf, int *fat, char *img);
struct FILEINFO *file_search(char *name, struct FILEINFO *finfo, int max);
char *file_loadfile2(int clustno, int *psize, int *fat);
unsigned short file_getfat(int *fat);
void file_setname(struct FILEINFO *finfo, char *name);
int file_removefile(char *filename, int *fat);
struct FILEINFO *file_createfile(char *filename, int *fat);
void file_writefile(int clustno, int size, char *buf, int *fat, char *img);
void file_readfont(char *filename, UCHAR *fontbuf);

/* bootpack.c */
extern int *fat;
extern struct SHEET *sht_back;
extern int mouse_x, mouse_y;
void keywin_off(struct SHEET *key_win);
void keywin_on(struct SHEET *key_win);

/* tek.c */
int tek_getsize(unsigned char *p);
int tek_decomp(unsigned char *p, char *q, int size);

/* bmp.nasm */
int info_BMP(struct DLL_STRPICENV *env, int *info, int size, char *fp);
int decode0_BMP(struct DLL_STRPICENV *env, int size, char *fp, int b_type, char *buf, int skip);

/* jpeg.c */
int info_JPEG(struct DLL_STRPICENV *env, int *info, int size, char *fp);
int decode0_JPEG(struct DLL_STRPICENV *env, int size, char *fp, int b_type, char *buf, int skip);

/* pcic.c */
void control_pcic_write(int num, int data);
int control_pcic_read(int num);
int get_pcic_devices(void);

/* sound.c */
int detect_fmchip(void);
void senddata_adlib(int port, int data);
int readdata_adlib(void);
void test_adlib(void);
int reset_dsp(void);
void write_dsp(int data);
int read_dsp(void);
#define DSP_VERSION		0
#define DSP_SPKSTAT		1
int getdata_dsp(int id);

/* serial.c */
int detect_serialport(int com);
void init_serialport(int com, int div);
void send_char_serialport(int com, char c);
void send_string_serialport(int com, char *string);
int receive_stat_serialport(int com);
char recv_char_serialport(int com);
void inthandler23(int *esp);
void inthandler24(int *esp);

/* fdc.c */
void fdc_task(void);
void inthandler26(int *esp);

/* mpm.c */
void run_mpm(void);
void stop_mpm(void);
void task_mpm(void);
void show_mesbox(char *caption, char *message);
void close_mesbox(void);

/* log.c */
#define DATA_TO_KERNEL	0
#define DATA_TO_DEBUG	1
void init_log(void);
void show_log(struct CONSOLE *cons, int id);
void send_kernellog(char *data);
void send_debuglog(char *data, int var);

/* rtc.c */
int readdate_cmos(unsigned char *a);
void run_clock(void);
void stop_clock(void);
void clock_task(void);
